--[[ 
	Waitress Function
]]

Waitress_DragLock 			= false;
Waitress_BeingDragged 			= false;
Waitress_SummonDrinkSpellID		= nil;
Waitress_SummonDrinkSpellRank		= nil;
Waitress_BestDrinkName			= nil;
Waitress_SummonFoodSpellID		= nil;
Waitress_SummonFoodSpellRank		= nil;
Waitress_BestFoodName			= nil;
Waitress_FoodLocation			= {nil, nil};
Waitress_DrinkLocation			= {nil, nil};


function Waitress_OnLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function Waitress_Button_OnLoad()
   	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
   	this:RegisterForDrag("LeftButton");
end

function Waitress_OnEvent(event)
	if (event == "PLAYER_ENTERING_WORLD") then
		if (UnitClass("player") == "Mage") then
			this:RegisterEvent("LEARNED_SPELL_IN_TAB");
		else
			this:UnregisterEvent("PLAYER_ENTERING_WORLD");
			WaitressMinimapButton:Hide();
		end
	elseif (event == "LEARNED_SPELL_IN_TAB") then
		ResetAll();
	end
end

function Waitress_OnClick(arg1)
	ResetDrink();
	ResetFood();
	if (arg1 == "LeftButton") then
		Waitress_Drink();		
	elseif (arg1 == "RightButton") then
		Waitress_Eat();
	end
end

function Waitress_OnDragStart()
	if (not Waitress_DragLock and not Waitress_BeingDragged) then
		this:StartMoving();
		Waitress_BeingDragged = true;
	end
end

function Waitress_OnDragStop()
	if (Waitress_BeingDragged) then
		this:StopMovingOrSizing()
		Waitress_BeingDragged = false;
	end
end

function Waitress_Drink()
	ResetDrink();
	if (Waitress_DrinkLocation[1] == nil or Waitress_DrinkLocation[2] == nil) then
		Waitress_CheckBags();
	end
	if (Waitress_DrinkLocation[1] == -1 or Waitress_DrinkLocation[2] == -1) then
		if (Waitress_SummonDrinkSpellID > 0) then
			CastSpell(Waitress_SummonDrinkSpellID, "spell");
		else
			Print("You cant summon any drink!");
		end
	else
		if (UnitExists("target") and UnitIsPlayer("target") and UnitCanCooperate("player", "target")) then
			PickupContainerItem(Waitress_DrinkLocation[1],Waitress_DrinkLocation[2]);
			if (CursorHasItem()) then
				DropItemOnUnit("target");
			end	            
		else
			UseContainerItem(Waitress_DrinkLocation[1],Waitress_DrinkLocation[2]);
		end
	end
end

function Waitress_Eat()
	ResetFood();
	if (Waitress_FoodLocation[1] == nil or Waitress_FoodLocation[2] == nil) then
		Waitress_CheckBags();
	end
	if (Waitress_FoodLocation[1] == -1 or Waitress_FoodLocation[2] == -1) then
		if (Waitress_SummonFoodSpellID > 0) then
			CastSpell(Waitress_SummonFoodSpellID, "spell");
		else
			Print("You cant summon any food!");
		end
	else
		if (UnitExists("target") and UnitIsPlayer("target") and UnitCanCooperate("player", "target")) then
			PickupContainerItem(Waitress_FoodLocation[1],Waitress_FoodLocation[2]);
			if (CursorHasItem()) then
				DropItemOnUnit("target");
			end	            
		else
			UseContainerItem(Waitress_FoodLocation[1],Waitress_FoodLocation[2]);
		end
	end
end

function QuickBagCheck()
	if (Waitress_DrinkLocation[1] ~= nil or Waitress_DrinkLocation[2] ~= nil) then
		ResetDrink();
	end
	if (Waitress_FoodLocation[1] ~= nil or Waitress_FoodLocation[2] ~= nil) then
		ResetFood();
	end
end

function ResetDrink()
	Waitress_DrinkLocation			= {nil, nil};
end

function ResetFood()
	Waitress_FoodLocation			= {nil, nil};
end

function ResetAll()
	Waitress_SummonDrinkSpellID		= nil;
	Waitress_SummonDrinkSpellRank		= nil;
	Waitress_BestDrinkName			= nil;
	Waitress_SummonFoodSpellID		= nil;
	Waitress_SummonFoodSpellRank		= nil;
	Waitress_BestFoodName			= nil;
	ResetDrink();
	ResetFood();
end

function Print(string)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(string);
	end
end

function Waitress_CheckSpells()
	Waitress_SummonFoodSpellID		= -1;
	Waitress_SummonFoodSpellRank		= -1;
	Waitress_BestFoodName			= nil;
	Waitress_SummonDrinkSpellID		= -1;
	Waitress_SummonDrinkSpellRank		= -1;
	Waitress_BestDrinkName			= nil;
   	
	local		spellRank		= -1;

	for id = 1, 180 do 
		local spellName, subSpellName = GetSpellName(id, "spell");
		if (spellName) then
			if (spellName == "Conjure Food") then
				spellRank = -1;
				if (subSpellName == "Rank 1") then
					spellRank = 1;
				elseif (subSpellName == "Rank 2") then
					spellRank = 2;
				elseif (subSpellName == "Rank 3") then
					spellRank = 3;
				elseif (subSpellName == "Rank 4") then
					spellRank = 4;
				elseif (subSpellName == "Rank 5") then
					spellRank = 5;
				elseif (subSpellName == "Rank 6") then
					spellRank = 6;
				end
				if (spellRank > Waitress_SummonFoodSpellRank) then
					Waitress_SummonFoodSpellID   = id;
					Waitress_SummonFoodSpellRank   = spellRank;
				end
			elseif (spellName == "Conjure Water") then
				spellRank = -1;
				if (subSpellName == "Rank 1") then
					spellRank = 1;
				elseif (subSpellName == "Rank 2") then
					spellRank = 2;
				elseif (subSpellName == "Rank 3") then
					spellRank = 3;
				elseif (subSpellName == "Rank 4") then
					spellRank = 4;
				elseif (subSpellName == "Rank 5") then
					spellRank = 5;
				elseif (subSpellName == "Rank 6") then
					spellRank = 6;
				end
				if (spellRank > Waitress_SummonDrinkSpellRank) then
					Waitress_SummonDrinkSpellID   = id;
					Waitress_SummonDrinkSpellRank = spellRank;
				end
			end
		end
	end
	
	if (Waitress_SummonDrinkSpellRank == 1) then
		Waitress_BestDrinkName = "Conjured Water";
	elseif (Waitress_SummonDrinkSpellRank == 2) then
		Waitress_BestDrinkName = "Conjured Fresh Water";
	elseif (Waitress_SummonDrinkSpellRank == 3) then
		Waitress_BestDrinkName = "Conjured Purified Water";
	elseif (Waitress_SummonDrinkSpellRank == 4) then
		Waitress_BestDrinkName = "Conjured Spring Water";
	elseif (Waitress_SummonDrinkSpellRank == 5) then
		Waitress_BestDrinkName = "Conjured Mineral Water";
	elseif (Waitress_SummonDrinkSpellRank == 6) then
		Waitress_BestDrinkName = "Conjured Sparkling Water";
	elseif (Waitress_SummonDrinkSpellRank == 7) then
		Waitress_BestDrinkName = "Conjured Crystal Water";
	end

	if (Waitress_SummonFoodSpellRank == 1) then
		Waitress_BestFoodName = "Conjured Muffin";
	elseif (Waitress_SummonFoodSpellRank == 2) then
		Waitress_BestFoodName = "Conjured Bread";
	elseif (Waitress_SummonFoodSpellRank == 3) then
		Waitress_BestFoodName = "Conjured Rye";
	elseif (Waitress_SummonFoodSpellRank == 4) then
		Waitress_BestFoodName = "Conjured Pumpernickel";
	elseif (Waitress_SummonFoodSpellRank == 5) then
		Waitress_BestFoodName = "Conjured Sourdough";
	elseif (Waitress_SummonFoodSpellRank == 6) then
		Waitress_BestFoodName = "Conjured Sweet Roll";
	end
end


function Waitress_CheckBags()
	if (Waitress_SummonFoodSpellRank == nil or Waitress_SummonDrinkSpellRank == nil) then
		Waitress_CheckSpells();
	end
	
	Waitress_DrinkLocation = {-1,-1};
	Waitress_FoodLocation = {-1,-1};
	
	if(Waitress_BestDrinkName ~= nil or Waitress_BestFoodName ~= nil) then
		for bag = 4, 0, -1 do
			local size = GetContainerNumSlots(bag);
			if (size > 0) then
				for slot=1, size, 1 do
					local _, itemCount = GetContainerItemInfo(bag, slot);
					if (itemCount) then
						if(Waitress_BestDrinkName ~= nil) then
							if (string.find(GetContainerItemLink(bag,slot),Waitress_BestDrinkName)) then
								Waitress_DrinkLocation = {bag,slot};
							end
						end
						if(Waitress_BestFoodName ~= nil) then
							if (string.find(GetContainerItemLink(bag,slot),Waitress_BestFoodName)) then
								Waitress_FoodLocation = {bag,slot};
							end
						end
						
					end
				end
			end
		end
	end
end
